package com.blamejared.compat.extrautils2;

import com.blamejared.ModTweaker;
import com.blamejared.mtlib.helpers.InputHelper;
import com.blamejared.mtlib.helpers.LogHelper;
import com.blamejared.mtlib.helpers.StackHelper;
import com.blamejared.mtlib.utils.BaseAction;
import com.rwtema.extrautils2.api.machine.IMachineRecipe;
import com.rwtema.extrautils2.api.machine.MachineSlotFluid;
import com.rwtema.extrautils2.api.machine.MachineSlotItem;
import com.rwtema.extrautils2.api.machine.XUMachineCrusher;
import crafttweaker.annotations.ModOnly;
import crafttweaker.annotations.ZenRegister;
import crafttweaker.api.item.IItemStack;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fluids.FluidStack;
import org.apache.commons.lang3.tuple.Pair;
import stanhebben.zenscript.annotations.Optional;
import stanhebben.zenscript.annotations.ZenClass;
import stanhebben.zenscript.annotations.ZenMethod;

@ZenClass("mods.extrautils2.Crusher")
@ModOnly("extrautils2")
@ZenRegister
public class Crusher {
   @ZenMethod
   public static void add(IItemStack output, IItemStack input, @Optional IItemStack secondaryOutput, @Optional float secondaryChance) {
      ModTweaker.LATE_ADDITIONS.add(new Add(InputHelper.toStack(output), InputHelper.toStack(input), InputHelper.toStack(secondaryOutput), secondaryChance));
   }

   @ZenMethod
   public static void remove(IItemStack input) {
      ModTweaker.LATE_REMOVALS.add(new Remove(input));
   }

   private static class Remove extends BaseAction {
      private IItemStack input;

      public Remove(IItemStack input) {
         super("Crusher");
         this.input = input;
      }

      public void apply() {
         List<IMachineRecipe> toRemove = new ArrayList();
         Iterator var2 = XUMachineCrusher.INSTANCE.recipes_registry.iterator();

         IMachineRecipe recipe;
         while(var2.hasNext()) {
            recipe = (IMachineRecipe)var2.next();
            Iterator var4 = recipe.getJEIInputItemExamples().iterator();

            while(var4.hasNext()) {
               Pair<Map<MachineSlotItem, List<ItemStack>>, Map<MachineSlotFluid, List<FluidStack>>> mapMapPair = (Pair)var4.next();
               Iterator var6 = ((List)((Map)mapMapPair.getKey()).get(XUMachineCrusher.INPUT)).iterator();

               while(var6.hasNext()) {
                  ItemStack stack = (ItemStack)var6.next();
                  if (StackHelper.matches(this.input, InputHelper.toIItemStack(stack))) {
                     toRemove.add(recipe);
                  }
               }
            }
         }

         var2 = toRemove.iterator();

         while(var2.hasNext()) {
            recipe = (IMachineRecipe)var2.next();
            XUMachineCrusher.INSTANCE.recipes_registry.removeRecipe(recipe);
         }

      }

      protected String getRecipeInfo() {
         return LogHelper.getStackDescription(this.input);
      }
   }

   private static class Add extends BaseAction {
      private ItemStack output;
      private ItemStack input;
      private ItemStack secondaryOutput;
      private float secondaryChance;

      public Add(ItemStack output, ItemStack input, ItemStack secondaryOutput, float secondaryChance) {
         super("Crusher");
         this.output = output;
         this.input = input;
         this.secondaryOutput = secondaryOutput;
         this.secondaryChance = secondaryChance;
         if (!secondaryOutput.func_190926_b() && secondaryChance <= 0.0F) {
            this.secondaryChance = 100.0F;
         }

      }

      public void apply() {
         XUMachineCrusher.addRecipe(this.input, this.output, this.secondaryOutput, this.secondaryChance);
      }

      protected String getRecipeInfo() {
         return LogHelper.getStackDescription(this.output);
      }
   }
}
